dot/emacs: Get `ido' to insist on getting the first letter right.
[profile] / dot / shell-rc
CommitLineData
74a53e28
MW
1### -*-sh-*-
2###
3### Common per-shell configuration.
4
5###--------------------------------------------------------------------------
6### Utilities.
7
8__mdw_programp () { type >/dev/null 2>&1 "$1"; }
9
10__mdw_source_if_exists () {
11 local i
12 for i in "$@"; do
13 if [ -r "$i" ]; then . "$i"; fi
14 done
15}
16
17###--------------------------------------------------------------------------
18### Prompt machinery.
19
20__mdw_set_prompt_hacks () { host=$(hostname); dir=""; }
21
22__mdw_set_prompt_pieces () {
23 local hqual
24 hqual=""
25
26 ## Fancy highlighting in some terminals.
27 local bold unbold nl gitcolour rccolour uncolour
55360ba3
MW
28 local host dir more
29 bold="" unbold="" nl="" gitcolour="" rccolour="" uncolour="" more=""
74a53e28
MW
30 __mdw_set_prompt_hacks
31
32 ## Choose the right delimiters. Highlight root prompts specially;
33 ## highlight when I'm running as some other user. Highlight when this
34 ## isn't the outermost shell on the terminal.
35 local left right user u tty
2ab43296 36 user=${USER-${LOGNAME-$(id -un)}}
74a53e28
MW
37 case $(id -u) in
38 0)
39 left=$(echo « | iconv -f UTF-8 -t //translit)
40 right=$(echo » | iconv -f UTF-8 -t //translit)
41 ;;
42 *)
43 case $user in
44 mdw | mwooding | nemo) u="" left="[" right="]" ;;
45 *) u="$user@" left="{" right="}" ;;
46 esac
47 tty=$(tty)
48 case "$__mdw_tty" in
49 "$tty") left="<" right=">" ;;
50 *) __mdw_tty=$tty; export __mdw_tty ;;
51 esac
52 ;;
53 esac
54
55 ## If this session is insecure then highlight that.
56 local sec_l sec_r h
57 h=$(hostname)
58 case ${SSH_CLIENT-nil},${SCHROOT_CHROOT_NAME-nil},$__mdw_sechost in
59 nil,nil,"$h") sec_l="" sec_r="" ;;
60 nil,nil,*) sec_l="(" sec_r=")" ;;
61 *) sec_l="" sec_r=""
62 esac
63
1a1af55e
MW
64 ## If this is an schroot environment or some other interesting augmented
65 ## environment then point this out.
74a53e28 66 hqual="$hqual${SCHROOT_CHROOT_NAME+/$SCHROOT_CHROOT_NAME}"
34d4fb89 67 hqual="$hqual${MDW_BUILDENV+/$MDW_BUILDENV}"
74a53e28
MW
68
69 ## Put together the main pieces.
70 __mdw_prompt_left="$nl$bold$left$sec_l$u$host$hqual$sec_r$dir"
71 __mdw_prompt_git_left="$unbold$gitcolour"
72 __mdw_prompt_git_right="$uncolour$bold"
73 __mdw_prompt_rc_left="$unbold$rccolour"
74 __mdw_prompt_rc_right="$uncolour$bold"
75 __mdw_prompt_right="$right$unbold"
55360ba3 76 __mdw_prompt_more=" $more$bold>$unbold "
74a53e28
MW
77}
78
79__mdw_set_prompt () {
062b450d 80 case "${TERM-dumb}:${INSIDE_EMACS+$INSIDE_EMACS}" in
d281a650 81 dumb:)
55bd0261
MW
82 case $(id -u) in 0) PS1='# ' ;; *) PS1='$ ' ;; esac
83 PS2='> '
84 ;;
85 *)
86 __mdw_last_rc=$?
87 local git rc
88 if type __git_ps1 >/dev/null 2>&1; then
89 git="$__mdw_prompt_git_left$(__git_ps1)$__mdw_prompt_git_right"
90 else
91 git=""
92 fi
93 case $__mdw_last_rc in
94 0) rc="" ;;
95 *) rc="$__mdw_prompt_rc_left rc=$__mdw_last_rc$__mdw_prompt_rc_right" ;;
96 esac
97 PS1="$__mdw_prompt_left$git$rc$__mdw_prompt_right"
55360ba3 98 PS2="$PS1$__mdw_prompt_more"
55bd0261
MW
99 unset __mdw_last_rc
100 ;;
74a53e28 101 esac
74a53e28
MW
102}
103
104__mdw_precmd () {
105 __mdw_set_prompt
106 case ${STY+t} in
107 t) printf "\ek%s\e\\" "$__mdw_shell" ;;
108 esac
109}
110
111__mdw_preexec () {
112 case ${STY+t} in
113 t) printf "\ek%s\e\\" "$1" ;;
114 esac
115}
116
117###--------------------------------------------------------------------------
118### Some handy aliases.
119
120alias cx='chmod +x'
121alias which="command -v"
122alias rc="rc -l"
123rootly () {
124 case $# in 0) set -- "${SHELL-/bin/sh}" ;; esac
125 $__MDW_ROOTLY "$@"
126}
127alias r=rootly
128alias re="rootly $EDITOR"
129alias pstree="pstree -hl"
130alias cdtmp='cd ${TMPDIR-/tmp}'
131alias pushtmp='pushd ${TMPDIR-/tmp}'
132alias e="$EDITOR"
133alias svn="svnwrap svn"
134alias @="ssh"
daeece4b 135alias make="nice make"
74a53e28
MW
136
137###--------------------------------------------------------------------------
138### Colour output.
139
140## Arrange for `ls' output to be in colour.
141if __mdw_programp dircolors; then eval $(dircolors -b "$HOME/.dircolors")
142else unset LS_COLORS; fi
143
144unalias ls 2>/dev/null || :
145ls () {
146 if [ -t 1 ]; then command ls $LS_OPTIONS ${LS_COLORS+--color=auto} "$@"
147 else command ls "$@"; fi
148}
149
150## Arrange for `grep' output to be in colour.
151export GREP_COLORS="mt=01;31:ms=01;31:mc=031;31:fn=36:ln=36:bn=36:se=34"
152
153greplike () {
154 local grep=$1; shift
155 if [ -t 1 ]; then
156 command $grep ${GREP_COLORS+--color=always} "$@" | mdw-pager
157 else
158 command $grep "$@"
159 fi
160}
161alias grep="greplike grep"
162alias egrep="greplike egrep"
163alias fgrep="greplike fgrep"
164alias zgrep="greplike zgrep"
165
049cd015
MW
166## Arrange for `diff' output to be in colour.
167export DIFF_COLORS="hd=1:ln=36:ad=32:de=31"
168difflike () {
169 local diff=$1; shift
170 if [ -t 1 ]; then
171 command $diff \
172 ${DIFF_COLORS+--color=always} \
173 ${DIFF_COLORS+--palette="$DIFF_COLORS"} \
174 "$@" | mdw-pager
175 else
176 command $diff "$@" | cat
177 fi
178}
179alias diff="difflike diff"
180
74a53e28
MW
181###--------------------------------------------------------------------------
182### Other hacks.
183
184## Turn off pagers inside Emacs shell buffers.
185case "$INSIDE_EMACS" in
186 2[2-9].*,comint | [3-9][0-9].*,comint) export PAGER=cat ;;
187esac
188
189###--------------------------------------------------------------------------
190### More complicated shell functions.
191
192## xt [@HOST] XTERM-ARGS
193##
194## Open a terminal, maybe on a remote host.
195xt () {
196 case "$1" in
197 @*)
198 local remote=${1#@} title
199 shift
200 if [ $# -gt 0 ]; then
201 title="xterm [$remote] $1"
202 else
203 title="xterm [$remote]"
204 fi
205 (xterm -title "$title" -e ssh $remote "$@" &)
206 ;;
207 *)
208 (xterm "$@" &)
209 ;;
210 esac
211}
212
213## core [y|n]
214##
215## Tweak core dumps on and off, or show the current status.
216core () {
217 case "x$1" in
218 xon|xy|xyes) ulimit -Sc $(ulimit -Hc) ;;
219 xoff|xn|xno) ulimit -Sc 0 ;;
220 x)
221 local l=$(ulimit -Sc)
222 case $l in
223 0) echo "Core dumps disabled" ;;
224 unlimited) echo "Core dumps enabled" ;;
225 *) echo "Core dump limit is $l blocks" ;;
226 esac
227 ;;
228 *)
229 echo >&2 "usage: core [y|n]"
230 return 1
231 ;;
232 esac
233}
234
235## world [NAME]
236##
237## Set current security world to NAME. With no NAME, print the currently
238## selected world.
239world () {
240 local nfast=${NFAST_HOME-/opt/nfast}
241 local kmdata
242 case "$#" in
243 0)
244 echo "${NFAST_KMDATA#$nfast/kmdata-}"
245 ;;
246 *)
247 if [ -d "$1" ]; then
248 kmdata=$1
249 elif [ -d "$nfast/kmdata-$1" ]; then
250 kmdata=$nfast/kmdata-$1
251 else
252 echo >&2 "world: can't find world $1"
253 return 1
254 fi
255 shift
256 case "$#" in
257 0) export NFAST_KMDATA=$kmdata ;;
258 *) "$@" ;;
259 esac
260 ;;
261 esac
262}
263
264## path-add [VAR] DIR
265##
266## Add DIR to the beginning of PATH-like variable VAR (defaults to PATH) if
267## it's not there already.
268path_add () {
269 local pathvar export dir val
270 case $# in
271 1) pathvar=PATH dir=$1 export="export PATH" ;;
272 2) pathvar=$1 dir=$2 export=: ;;
273 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
274 esac
275 eval val=\$$pathvar
276 case ":$val:" in
277 *:"$dir":*) ;;
278 *) val=$dir:$val ;;
279 esac
280 eval $pathvar=\$val
281 eval $export
282}
283
284## path-remove [VAR] DIR
285##
286## Remove DIR from PATH-like variable VAR (defaults to PATH); it's not an
287## error if DIR isn't in VAR.
288path_remove () {
289 local pathvar export dir val
290 case $# in
291 1) pathvar=PATH dir=$1 export="export PATH" ;;
292 2) pathvar=$1 dir=$2 export=: ;;
293 *) echo >&2 "Usage: $0 [VAR] DIR"; return 1 ;;
294 esac
295 eval val=\$$pathvar
296 case ":$val:" in
297 :"$dir":) val= ;;
298 :"$dir":*) val=${val#$dir:} ;;
299 *:"$dir":) val=${val%:$dir} ;;
300 *:"$dir":*) val=${val%%:$dir:*}:${val#*:$dir:} ;;
301 esac
302 eval $pathvar=\$val
303 eval $export
304}
305
306## pathhack [-f] +HACK|-HACK...
307##
308## Each HACK refers to a subdirectory of `~/bin/hacks'. A hack name preceded
309## by `+' adds the directory to the PATH; a `-' removes. Adding a hack
310## that's already on the PATH doesn't do anything unless `-f' is set, in
311## which case it gets moved to the beginning. With no arguments, print the
312## currently installed hacks.
313pathhack () {
314 local p e force arg hack dir
315 p=$PATH
316 if [ $# -eq 0 ]; then
317 while :; do
318 e=${p%%:*}
319 case "$e" in "$HOME/bin/hacks/"*) echo ${e#$HOME/bin/hacks/} ;; esac
320 case "$p" in *:*) p=${p#*:} ;; *) break ;; esac
321 done
322 return
323 fi
324 force=nil
325 while [ $# -gt 0 ]; do
326 arg=$1
327 case "$arg" in
328 -f | --force) force=t; shift; continue ;;
329 --) shift; break ;;
330 [-+]*) ;;
331 *) break; ;;
332 esac
333 hack=${arg#[+-]}
334 dir=$HOME/bin/hacks/$hack
335 if ! [ -d "$dir" ]; then
336 echo "$0: path hack $hack not found"
337 return 1
338 fi
339 case "$arg,$force,:$PATH:" in
340 -*,*,*:"$dir":*) path_remove p "$dir" ;;
341 +*,t,*:"$dir":*) path_remove p "$dir"; path_add p "$dir" ;;
342 +*,nil,*:"$dir":*) ;;
343 +*,*) path_add p "$dir" ;;
344 esac
345 shift
346 done
347 if [ $# -eq 0 ]; then PATH=$p; export PATH
348 else PATH=$p "$@"; fi
349}
350
351###--------------------------------------------------------------------------
352### Finishing touches.
353
4cb8b8da
MW
354## Make sure `$HOME/bin' is on the path.
355path_add "$HOME/bin"
356
6054bdb6
MW
357## Set the temporary directory again. (A setuid or setgid program may have
358## unhelpfully forgotten this for us.)
0a030a39
MW
359case ${TMPDIR+t} in
360 t) ;;
361 *) if __mdw_programp tmpdir; then eval $(tmpdir -b); fi ;;
362esac
6054bdb6 363
74a53e28
MW
364## For `root' use -- some simple molly-guards.
365case $(id -u) in
366 0)
367 alias rm="rm -i" cp="cp -i" mv="mv -i"
368 set -o noclobber
369 ;;
370esac
371
372## Run any local hooks.
373__mdw_source_if_exists "$HOME/.shell-local"
374
375###----- That's all, folks --------------------------------------------------